package cds.aida.gui;
/* $Id: AidaContentHandlerFactory.java,v 1.1 2007/06/04 14:18:21 beugnot Exp $ */
import java.net.ContentHandler;
import java.net.ContentHandlerFactory;

/**
 * Http connexion content handler factory
 */
public class AidaContentHandlerFactory implements ContentHandlerFactory {

	/* (non-Javadoc)
	 * @see java.net.ContentHandlerFactory#createContentHandler(java.lang.String)
	 */
	public ContentHandler createContentHandler(String mimetype) {
		String lowermime=mimetype.toLowerCase().trim();
		Logger.getInstance().log(
				Logger.TRACE,
				"AidaContentHandlerFactory.mime("+mimetype+")"); //$NON-NLS-1$ //$NON-NLS-2$
		if(lowermime.startsWith("text/plain") || //$NON-NLS-1$
				lowermime.startsWith("text/html") || //$NON-NLS-1$
				lowermime.startsWith("application/x-cgi")) { //$NON-NLS-1$
			return new TextContentHandler();
		}
		else if(lowermime.startsWith("image/fits") || //$NON-NLS-1$
				lowermime.startsWith("application/x-fits")) { //$NON-NLS-1$
			return new FitsContentHandler();
		}
		return null;
	}
}
