package cds.aida.gui;
/* $Id: GlenView.java,v 1.1 2007/06/04 14:18:21 beugnot Exp $ */
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Image;
import java.awt.KeyboardFocusManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.KeyEvent;
import java.io.BufferedReader;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ActionMap;
import javax.swing.BorderFactory;
import javax.swing.InputMap;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.KeyStroke;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.UIManager.LookAndFeelInfo;
import javax.swing.plaf.FontUIResource;
import javax.swing.tree.DefaultMutableTreeNode;



import cds.aida.tool.ToolsList;
import cds.aida.w1.WS1;
import cds.aida.wsJlow.ExecServAction;
import cds.aida.wsJlow.GetAllObjectsAction;
import cds.aida.wsJlow.GetObjectAction;
import cds.aida.wsJlow.TaskListAction;
import cds.aida.wsJlow.WSJ;
import cds.jlow.client.codec.action.LoadAsAction;
import cds.jlow.client.codec.action.SaveAsAction;
import cds.jlow.client.descriptor.Attributs;
import cds.jlow.client.descriptor.AttributsFactory;
import cds.jlow.client.descriptor.Registerer;
import cds.jlow.client.graph.DefaultMPopupMenu;
import cds.jlow.client.graph.IGraphJ;
import cds.jlow.client.graph.IManagerPopupMenu;
import cds.jlow.client.graph.Jlow;
import cds.jlow.client.graph.event.DefaultDTL;
import cds.jlow.client.util.ToHtmlModule;
import cds.jlow.client.util.ToStringModule;
import cds.jlow.client.view.action.PropertyAction;
import cds.jlow.descriptor.IDescriptor;
import cds.jlow.descriptor.TaskDescriptor;


/**
 * Main GUI view, i.e.
 * View combining the view for the list of tools (Tools)
 * and the view for the workspaces (WorkSpace)
 */
public class GlenView extends JPanel
implements Observer, ActionListener, ComponentListener {
	private Vector workspaces; 
	int wscounter=1; // only used for tab names
	// visu.
	private ToolsList tlist;
	private TListView tv;
	private JTabbedPane wstabs;
	private JSplitPane spane;
	private JMenuBar menu;
	
	protected Action
	actionExit,
	actionGetList, actionResetList,
	actionIncFont, actionDecFont,
	actionAddWS1,  actionAddWSWF,
	actionClearWS, actionClearAllWS,
	actionPrevWS,  actionNextWS,
	actionDisplayAbout;
	
	/**
	 * Construct the application main view,
	 * with a tool list and its view,
	 * the workspaces view with a default workspace,
	 * and the GUI to tie them all.
	 */
	public GlenView() {
		super();
		tlist = new ToolsList();
		tv = new TListView(tlist);
		this.initActions();
		this.initComponents();
		if(Conf.getInstance().getBool("tools.getlistonload",true)) { //$NON-NLS-1$

			tlist.fetchList();
			//tlist.resetList();
			
			//ToolsView tv = new ToolsView(tlist);
		}
	}

	/**
	 * GUI components 
	 */
	private void initComponents() {
		L10N lion=L10N.getInstance();

		// menu bar
		menu=new JMenuBar();
		menu.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));

		// File menu
		JMenu filemenu=new JMenu(lion.get("menu.file.label","File")); //$NON-NLS-1$ //$NON-NLS-2$
		filemenu.setMnemonic('F');
		filemenu.add(new JMenuItem(actionExit));
		menu.add(filemenu);
		
		// Tools menu
		JMenu toolsmenu=new JMenu(lion.get("menu.tools.label","Tools")); //$NON-NLS-1$ //$NON-NLS-2$
		toolsmenu.setMnemonic('T');
		toolsmenu.add(new JMenuItem(actionGetList));
		toolsmenu.add(new JMenuItem(actionResetList));
		menu.add(toolsmenu);
		
		// Workspaces menu
		JMenu wsmenu=new JMenu(lion.get("menu.ws.label","Workspaces")); //$NON-NLS-1$ //$NON-NLS-2$
		wsmenu.setMnemonic('W');
		wsmenu.add(new JMenuItem(actionAddWS1));
		wsmenu.add(new JMenuItem(actionAddWSWF));
		wsmenu.add(new JMenuItem(actionClearWS));
		wsmenu.add(new JMenuItem(actionClearAllWS));
		wsmenu.add(new JSeparator());
		wsmenu.add(new JMenuItem(actionPrevWS));
		wsmenu.add(new JMenuItem(actionNextWS));
		menu.add(wsmenu);
		
		// Look & Feel menu
		JMenu uimenu=new JMenu(lion.get("menu.lnf.label","L&F")); //$NON-NLS-1$ //$NON-NLS-2$
		uimenu.setMnemonic('L');
		LookAndFeelInfo[] lnfs=UIManager.getInstalledLookAndFeels();
		for(int i=0;i<lnfs.length;i++) {
			JMenuItem lnf=new JMenuItem(lnfs[i].getName());
			lnf.addActionListener(
					new LookAndFeelActionListener(lnfs[i].getClassName()));
			uimenu.add(lnf);
		}
		uimenu.add(new JSeparator());
		uimenu.add(new JMenuItem(actionIncFont));
		uimenu.add(new JMenuItem(actionDecFont));
		menu.add(uimenu);

		// About menu
		JMenu aboutmenu=new JMenu(lion.get("menu.about.label", "?")); //$NON-NLS-1$ //$NON-NLS-2$
		aboutmenu.add(new JSeparator());
		aboutmenu.add(new JMenuItem(actionDisplayAbout));
		menu.add(aboutmenu);

		
		
		
		
		// workspaces and workspaces tabs
		workspaces=new Vector();
		wstabs=new JTabbedPane();
		addDefaultWSTab();
		
		// composition
		spane=new JSplitPane();
		spane.add(tv,JSplitPane.LEFT);
		spane.add(wstabs,JSplitPane.RIGHT);
		// iokdbg: no hardcoded (and understand why 0.42 don't divide at 42%)
		spane.setDividerLocation(210);
		spane.addComponentListener(this);
		this.setLayout(new BorderLayout());
		this.add(menu, BorderLayout.NORTH);
		this.add(spane, BorderLayout.CENTER);
	}
	
	/**
	 * Remove all the workspaces (and thus WS tabs)
	 */
	private void clearAllWSTabs() {
		wstabs.removeAll();
		workspaces.removeAllElements();
		addDefaultWSTab();
	}
	/**
	 * remove current workspace / WS Tab
	 */
	private void clearWSTab() {
		int idx=wstabs.getSelectedIndex();
		if(idx!=-1) {
			wstabs.removeTabAt(idx);
			workspaces.remove(idx);
		}
	}
	/**
	 * Add a default workspace tab
	 */
	private void addDefaultWSTab() {
		addWSLogTab();
		addWSHelpTab();
	}
	/**
	 * Add a Help "workspace" tab
	 */
	private void addWSHelpTab() {
//		WSHelp ws=new WSHelp();
//		workspaces.add(ws);
//		WSHelpView wsv=new WSHelpView(ws);
		workspaces.add("WSHelp"); //$NON-NLS-1$
		WSHelpView wsv=new WSHelpView();
		String tabname=
			wstabs.getTabCount()+": "+ //$NON-NLS-1$
			L10N.getInstance().get("wshelp.tab.label","Help"); //$NON-NLS-1$ //$NON-NLS-2$
		wstabs.add(tabname,wsv);
		wstabs.setSelectedComponent(wsv);
	}
	private void addWSLogTab() {
		workspaces.add("WSLog"); //$NON-NLS-1$
		WSLogView wsv=new WSLogView();
		String tabname=
			wstabs.getTabCount()+": "+ //$NON-NLS-1$
			L10N.getInstance().get("wslog.tab.label","Logs"); //$NON-NLS-1$ //$NON-NLS-2$
		wstabs.add(tabname,wsv);
		wstabs.setSelectedComponent(wsv);
	}
	/**
	 * Add a new WS1 workspace tab
	 */
	private void addWS1Tab() {
		WS1 ws=new WS1();
		workspaces.add(ws);
		WS1View wsv=new WS1View(ws);
		String tabname=
			wscounter+++":"+ //$NON-NLS-1$
			//wstabs.getTabCount()+": "+
			L10N.getInstance().get("ws1.tab.label","WS1"); //$NON-NLS-1$ //$NON-NLS-2$
		wstabs.add(tabname,wsv);
		wstabs.setSelectedComponent(wsv);
	}
	

	
	/**
	 * Add a new WSWF workspace tab
	 */
	private void addWSWFTab() {
		WSJ wsj = new WSJ(tlist);
		Jlow ws = wsj.getGraph();
	/*	WSWF ws=new WSWF();
		ws.initReg(tools);
		workspaces.add(ws);
		WSWFView wsv=new WSWFView(ws);*/
		String tabname=
			wscounter+++":"+ //$NON-NLS-1$
			//wstabs.getTabCount()+": "+
			L10N.getInstance().get("wswf.tab.label","WSWF"); //$NON-NLS-1$ //$NON-NLS-2$
		wstabs.add(tabname,ws);
		wstabs.setSelectedComponent(ws);
	}
	/**
	 * Get current workspace
	 * @return workspace
	 */
	/*
	public WorkSpace getSelectedWorkspace() {
		int idx=wstabs.getSelectedIndex();
		try {
			WorkSpace ws=(WorkSpace)workspaces.elementAt(idx);
			return ws;
		}
		catch(ClassCastException cce) {
			Logger.getInstance().log(
					Logger.ERROR,
					"GlenView.getSelectedWorkspace: not a WorkSpace" //$NON-NLS-1$
					);
			return null;
		}
	}*/
	
	
	public void update(Observable o, Object oo) {
		Logger.getInstance().log(Logger.TRACE, "GlenView.update"); //$NON-NLS-1$
	}
	
	/**
	 * When a tool is selected in the list, send it to the workspace 
	 * @see cds.aida.ToolsListener#toolSelected(cds.aida.Tool)
	 */
	/*
	public void toolSelected(ToolsEvent e) {
		WorkSpace ws=this.getSelectedWorkspace();
		if(ws!=null) {
			ws.addTool(e.getSelectedTool());
		}
	}
	*/
	/** inc/decrement font size for the whole view components
	 * XXX: chk font bug when lnf switch
	 * @param adjust
	 */
	public void adjustFont(int adjust) {
        Object[] objs=
        	UIManager.getLookAndFeel().getDefaults().keySet().toArray();
        for(int i=0; i<objs.length; i++) {
            if(objs[i].toString().toUpperCase().indexOf(".FONT")!=-1) { //$NON-NLS-1$
                Font font = UIManager.getFont(objs[i]);
                font = font.deriveFont((float)(font.getSize()+adjust));
                UIManager.put(objs[i],new FontUIResource(font));
            }
        }
        SwingUtilities.updateComponentTreeUI(
        		Conf.getInstance().getGraphicRoot());
        repaint();
    }

	/**
	 */
	private void initActions() {
		ActionMap am=getActionMap();
		// most of the accelerator_keys are set within Actions
		// but adding some more or redundent
		InputMap im=getInputMap(WHEN_ANCESTOR_OF_FOCUSED_COMPONENT);

		// XXX it should prevent FocusManager to catch *-TAB keystrokes
		// however, it does not, yet.
		this.setFocusTraversalKeys(
				KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS,
				Collections.EMPTY_SET);
		this.setFocusTraversalKeys(
				KeyboardFocusManager.BACKWARD_TRAVERSAL_KEYS,
				Collections.EMPTY_SET);

		// tools related
		actionGetList=new ActionToolsGetList();
		am.put("getlist",actionGetList); //$NON-NLS-1$
		actionResetList=new ActionToolsResetList();
		am.put("resetlist",actionResetList); //$NON-NLS-1$
		
		// gui related
		actionIncFont=new ActionIncrementFontSize();
		am.put("incfont",actionIncFont); //$NON-NLS-1$
		actionDecFont=new ActionDecrementFontSize();
		am.put("decfont",actionDecFont); //$NON-NLS-1$
		im.put(KeyStroke.getKeyStroke("F4"), "incfont"); //$NON-NLS-1$ //$NON-NLS-2$
		im.put(KeyStroke.getKeyStroke("F3"), "decfont"); //$NON-NLS-1$ //$NON-NLS-2$
		im.put(KeyStroke.getKeyStroke("ctrl PLUS"), "incfont"); //$NON-NLS-1$ //$NON-NLS-2$
		im.put(KeyStroke.getKeyStroke("ctrl MINUS"), "decfont"); //$NON-NLS-1$ //$NON-NLS-2$

		// ws related
		actionAddWS1=new ActionAddWS1();
		am.put("addws1",actionAddWS1); //$NON-NLS-1$
		actionAddWSWF=new ActionAddWSWF();
		am.put("addwswf",actionAddWSWF); //$NON-NLS-1$
		actionClearWS=new ActionClearWorkspace();
		am.put("clearws",actionClearWS); //$NON-NLS-1$
		actionClearAllWS=new ActionClearAllWorkspaces();
		am.put("clearallws",actionClearAllWS); //$NON-NLS-1$
		actionPrevWS=new ActionPrevWS();
		am.put("wsprev",actionPrevWS); //$NON-NLS-1$
		actionNextWS=new ActionNextWS();
		am.put("wsnext",actionNextWS); //$NON-NLS-1$
		im.put(KeyStroke.getKeyStroke("typed n"),"wsnext"); //$NON-NLS-1$ //$NON-NLS-2$
		im.put(KeyStroke.getKeyStroke("typed p"),"wsprev"); //$NON-NLS-1$ //$NON-NLS-2$
		
		// others
		actionDisplayAbout=new ActionDisplayAbout();
		am.put("about",actionDisplayAbout); //$NON-NLS-1$
		actionExit=new ActionExit();
		am.put("exit",actionExit); //$NON-NLS-1$

	}
	class ActionToolsGetList extends AbstractAction {
		public ActionToolsGetList() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.tools.getlist","Refresh")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_R));
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl R")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			tlist.fetchList();
		}
	}
	class ActionToolsResetList extends AbstractAction {
		public ActionToolsResetList() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.tools.resetlist","Clear")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_C));
			//putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl C"));
		}
		public void actionPerformed(ActionEvent e) {
			tlist.resetList();
		}
	}
	class ActionAddWS1 extends AbstractAction {
		public ActionAddWS1() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.ws.addws1","New WS1")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_N));
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl N")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			addWS1Tab();
		}
	}
	class ActionAddWSWF extends AbstractAction {
		public ActionAddWSWF() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.ws.addwswf","New WSWF")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_W));
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl F")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			addWSWFTab();
		}
	}
	class ActionClearAllWorkspaces extends AbstractAction {
		public ActionClearAllWorkspaces() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.ws.clearall","Clear all workspaces")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_C));
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl X")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			clearAllWSTabs();
		}
	}
	class ActionClearWorkspace extends AbstractAction {
		public ActionClearWorkspace() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.ws.clear","Clear current workspace")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_W));
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl W")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			clearWSTab();
		}
	}
	class ActionNextWS extends AbstractAction {
		public ActionNextWS() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.ws.next","Next")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_N));
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl TAB")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			int i=wstabs.getSelectedIndex();
			int n=wstabs.getComponentCount();
			i++;
			if(i==n) { i=0; }
			wstabs.setSelectedIndex(i);
		}
	}
	class ActionPrevWS extends AbstractAction {
		public ActionPrevWS() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.ws.prev","Previous")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_P));
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl shift TAB")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			int i=wstabs.getSelectedIndex();
			int n=wstabs.getComponentCount();
			i--;
			if(i<0) { i=n-1; }
			wstabs.setSelectedIndex(i);
		}
	}
	class ActionIncrementFontSize extends AbstractAction {
		public ActionIncrementFontSize() {
			L10N lion=L10N.getInstance();
			putValue(NAME, lion.get("menu.lnf.incfont","Increase text size")); //$NON-NLS-1$ //$NON-NLS-2$
			// TODO: bugfix pb with "ctrl PLUS" keystroke not working
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("F4")); //$NON-NLS-1$
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl PLUS")); //$NON-NLS-1$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_I));
		}
		public void actionPerformed(ActionEvent e) {
			adjustFont(+1);
		}
	}
	class ActionDecrementFontSize extends AbstractAction {
		public ActionDecrementFontSize() {
			L10N lion=L10N.getInstance();
			putValue(NAME, lion.get("menu.lnf.decfont","Decrease text size")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl MINUS")); //$NON-NLS-1$
			// see ActionIncrementFontSize about this:
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("F3")); //$NON-NLS-1$
			putValue(MNEMONIC_KEY,new Integer(KeyEvent.VK_D));
		}
		public void actionPerformed(ActionEvent e) {
			adjustFont(-1);
		}
	}
	class ActionDisplayAbout extends AbstractAction {
		public ActionDisplayAbout() {
			L10N lion=L10N.getInstance();
			putValue(NAME,
					lion.get("about.label","About")+" "+ //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
					lion.get("main.name")); //$NON-NLS-1$
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("F1")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			AboutDialog ab=new AboutDialog();
			ab.showFrame();
		}
	}
	class ActionExit extends AbstractAction {
		public ActionExit() {
			L10N lion=L10N.getInstance();
			putValue(NAME,lion.get("menu.file.exit","Exit")); //$NON-NLS-1$ //$NON-NLS-2$
			putValue(ACCELERATOR_KEY,KeyStroke.getKeyStroke("ctrl Q")); //$NON-NLS-1$
		}
		public void actionPerformed(ActionEvent e) {
			// XXX: need of a softer exit ?
			System.exit(0);
		}
	}
	public void actionPerformed(ActionEvent e) {
		String cmd=e.getActionCommand();
		// using InputMap/ActionMap for most (every?) cases.
		// see initActions();
	}
	
	/* (non-Javadoc)
	 * @see java.awt.event.ComponentListener#componentHidden(java.awt.event.ComponentEvent)
	 */
	public void componentHidden(ComponentEvent e) {
	}
	/* (non-Javadoc)
	 * @see java.awt.event.ComponentListener#componentMoved(java.awt.event.ComponentEvent)
	 */
	public void componentMoved(ComponentEvent e) {
	}
	/* (non-Javadoc)
	 * @see java.awt.event.ComponentListener#componentResized(java.awt.event.ComponentEvent)
	 */
	public void componentResized(ComponentEvent e) {
	}
	/* (non-Javadoc)
	 * @see java.awt.event.ComponentListener#componentShown(java.awt.event.ComponentEvent)
	 */
	public void componentShown(ComponentEvent e) {
	}
}
