package cds.aida.gui;
/* $Id: L10N.java,v 1.1 2007/06/04 14:18:21 beugnot Exp $ */
import cds.aida.gui.Logger;

//import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * Localisation properties
 * (and display properties)
 *  @see cds.aida.gui.lion properties file
 */
public class L10N extends PropertiesHandler {
	private final String PROPERTIES_FILE="cds.aida.gui.lion"; //$NON-NLS-1$
	private static L10N lion=null;
	
	/**
	 * @see getInstance
	 */
	private L10N() {
		try {
			rb=ResourceBundle.getBundle(PROPERTIES_FILE);
		}
		catch(Exception e) {
			Logger.getInstance().log(
					Logger.WARNING,
					"L10N: Cannot get resource bundle for " //$NON-NLS-1$
					+PROPERTIES_FILE);
		}
	}
	
	/**
	 * Get instance of Conf singleton
	 * @return the only Conf instance
	 */
	public static synchronized L10N getInstance() {
		if(lion==null) {
			lion=new L10N();
		}
		return lion;
	}
	
	
//	// was duplicate w/ PropertiesHandler
//	
//	/**
//	 * Get value for key
//	 * @see Conf#get(String key,String default_value)
//	 * @param key
//	 * @return key's value or default value
//	 */
//	public String get(String key) {
//		return get(key,null);
//	}
//	/**
//	 * Get value associated with key, with default value.
//	 * If default value is null, default is "(key)"
//	 * @param key
//	 * @param default_value
//	 * @return key's value or default if key missing
//	 */
//	public String get(String key, String default_value) {
//		String v;
//		try {
//			v=rb.getString(key);
//		}
//		catch(Exception e) {
//			Logger.getInstance().log(
//					Logger.TRACE,
//					"property("+key+") missing"
//					);
//			v=(default_value!=null)?default_value:"("+key+")";
//		}
//		return v;
//	}
//	
//	/**
//	 * Get int value associated with key
//	 * @param key
//	 * @return int value or exception
//	 * @throws MissingResourceException if no suitable value.
//	 */
//	public int getInt(String key)
//	throws MissingResourceException {
//		return getInt(key,null);
//	}
//	/**
//	 * Get int value associated with key
//	 * May use default value if key has no suitable value
//	 * @param key
//	 * @param default_value (if null, might throw exception)
//	 * @return int value for key
//	 * @throws MissingResourceException if (key missing or key's value not int)
//	 * and not default value given
//	 */
//	public int getInt(String key, Integer default_value)
//	throws MissingResourceException {
//		String v;
//		int val;
//		try{
//			v=rb.getString(key);
//			val=new Integer(v).intValue();
//		}
//		catch(Exception e) {
//			
//			if(default_value!=null) {
//				return default_value.intValue();
//			}
//			// otherwise, cannot do better than:
//			throw new MissingResourceException(
//					"Resource("+key+") missing or not an integer",
//					ResourceBundle.class.toString(),
//					key
//					);
//		}
//		return val;
//	}

}
	
