package cds.aida.gui;
/* $Id: ToolW1View.java,v 1.3 2007/06/06 12:24:19 beugnot Exp $ */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.util.Observable;
import java.util.Observer;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.border.Border;

import cds.aida.gui.L10N;
import cds.aida.gui.Logger;
import cds.aida.tool.Tool;
import cds.aida.tool.ToolPort;


/**
 */
public class ToolW1View extends JPanel
implements Observer{
	protected ToolPort io;
	protected String labelprefix;
	// visu
	protected Border compborder;
	protected JTextArea comment;
	protected JLabel label;
	protected JLabel ready;
	protected JPanel custom;
	protected Box header, caption;

	public ToolW1View(ToolPort io) {
		L10N lion=L10N.getInstance();
		this.io=io;
		compborder=BorderFactory.createEmptyBorder(10,10,10,10);

		// Whole panel
		JPanel p=this;
		p.setOpaque(false);
		p.setLayout(new BorderLayout());
		p.setBorder(compborder);
		// Header
		header=new Box(BoxLayout.X_AXIS);
		header.setOpaque(false);
		// Caption, Input metas
		caption=new Box(BoxLayout.X_AXIS);
		caption.setOpaque(false);
		// Sets and adds components
		createLabel();
		createComment();
		createReady();
		setup();

		// custom input space, components layout
		custom=new JPanel();
		custom.setLayout(new BorderLayout());
		p.add(header,BorderLayout.NORTH);
		p.add(custom,BorderLayout.CENTER);
		p.add(caption,BorderLayout.SOUTH);
	}
	public void setup() {
		header.removeAll();
		setComment();
		setLabel();
		setReady();
		// header.add(comment);
		caption.add(label);
		caption.add(ready);
		
	}
	protected void createComment() {
		comment=new JTextArea("1"); //$NON-NLS-1$
		comment.setDropTarget(null);
		comment.setLineWrap(true);
		comment.setWrapStyleWord(true);
		comment.setOpaque(false);
		comment.setEditable(false);
	}
	protected void clearComment() {
		header.remove(comment);
	}
	protected void setComment() {
		clearComment();
		String tcomment=io.getComment();
		if(tcomment!=null && !tcomment.equals("")) { //$NON-NLS-1$
			comment.setText(tcomment);
			header.add(comment);
		}
	}
	protected void createLabel() {
		labelprefix=L10N.getInstance().get("tool.ioname.label","Name")+": "; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		label=new JLabel(""); //$NON-NLS-1$
		Font font=label.getFont();
		Font tnof=font.deriveFont(Font.ITALIC,13f); // iokdbg: hardcoded
		label.setFont(tnof);
		label.setOpaque(false);
		label.setBorder(compborder);
	}
	protected void clearLabel() {
		caption.remove(label);
	}
	protected void setLabel() {
		clearLabel();
		String tname=io.getName();
		if(tname!=null && !tname.equals("")) { //$NON-NLS-1$
			label.setText(labelprefix+tname);
		}
		else {
			label.setText(""); //$NON-NLS-1$
		}
	}
	protected void clearReady() {
		caption.remove(ready);
	}
	protected void createReady() {
		ready=new JLabel(""); //$NON-NLS-1$
		Font font=ready.getFont();
		Font tnof=font.deriveFont(Font.BOLD,13f); // iokdbg: hardcoded
		ready.setFont(tnof);
	}
	protected void setReady() {
		// clearReady();
		L10N lion=L10N.getInstance();
		if(io.isReady()) {
			ready.setText(
				lion.get(
						"tool.io.ready", //$NON-NLS-1$
						"Ready")); //$NON-NLS-1$
			ready.setForeground(Color.GREEN);
		}
		else {
			ready.setText(
					lion.get(
							"tool.io.notready", //$NON-NLS-1$
							"Not ready")); //$NON-NLS-1$
			ready.setForeground(Color.RED);
		}
		// caption.add(ready);
	}
	/**
	 * @return a default dimension for the ToolIOView if displayed alone,
	 * e.g. in a popup frame 
	 */
	public Dimension getDefaultDimension() {
		Dimension d=new Dimension();
		L10N lion=L10N.getInstance();
		int x=lion.getInt("dialogs.size.x",new Integer(642)); //$NON-NLS-1$
		int y=lion.getInt("dialogs.size.y",new Integer(542)); //$NON-NLS-1$
		d.setSize(x,y);
		return d;
	}
	/**
	 * @return a box where one can add buttons to the ToolIOView
	 */
	public Box getButtonBar() {
		return caption;
	}
	public void update(Observable o, Object oo) {
		Logger.getInstance().log(
				Logger.TRACE,
				"ToolIOView.update()"); //$NON-NLS-1$
		setup();
	}
}
