package cds.aida.w1;
/* $Id: ToolPortViewNumeric.java,v 1.1 2007/06/06 12:24:19 beugnot Exp $ */

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.util.Enumeration;
import java.util.Observable;
import java.util.Observer;

import cds.aida.gui.L10N;
import cds.aida.gui.ToolW1View;
import cds.aida.tool.ToolPort;
import cds.jlow.descriptor.IPortDescriptor;


/**
 */
public class ToolPortViewNumeric extends ToolW1View
implements Observer, KeyListener {

	JDigitTextField field; // XXX only digit, too strong for numeric.
	
	public ToolPortViewNumeric(ToolPort io) {
		super(io);
		io.addObserver(this);
		field=new JDigitTextField();
		field.addKeyListener(this);
		reflectModelValue();
		if(io.getPosition() != IPortDescriptor.INPUT) {
			field.setEditable(false);
		}
		custom.add(field,BorderLayout.CENTER);
	}
	protected void reflectModelValue() {
		Enumeration e=io.getValues();
		if((e!=null)&&e.hasMoreElements()) {
			field.setText(e.nextElement().toString());
		}
		else {
			field.setText(""); //$NON-NLS-1$
		}
	}
	public void update(Observable o, Object oo) {
		super.update(o,oo);
		reflectModelValue();
	}
	public void keyReleased(KeyEvent e) {
		io.addValue(field.getText());
	}
	public void keyPressed(KeyEvent e) {
	}
	public void keyTyped(KeyEvent e) {
	}
	
	public Dimension getDefaultDimension() {
		Dimension d=new Dimension();
		L10N lion=L10N.getInstance();
		int x=lion.getInt("tool.io.type.numeric.x",new Integer(442)); //$NON-NLS-1$
		int y=lion.getInt("tool.io.type.numeric.y",new Integer(142)); //$NON-NLS-1$
		d.setSize(x,y);
		return d;
	}
}
