package cds.aida.w1;
/* $Id: WS1.java,v 1.2 2007/06/06 12:24:19 beugnot Exp $ */
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.io.Serializable;
import java.util.Observable;
import java.util.Observer;

import cds.aida.gui.Logger;
import cds.aida.gui.WS1View;
import cds.aida.gui.WorkSpace;
import cds.aida.tool.Tool;
import cds.jlow.client.graph.event.GraphDescriptorListener;

import javax.swing.JPanel;


/**
 * A workspace implementation for only 1 tool
 */
public class WS1  extends JPanel implements Serializable {
	private Tool tool;
	private ObservableWorkSpace ows;
	public WS1() {
		initObservable();
	}
	/**
	 * add the tool in the workspace,
	 * i.e. set the workspace only tool
	 * @param tool
	 */
	public void addTool(Tool tool) {
		setTool(tool);
	}
	/**
	 * @return Returns the tool.
	 */
	public Tool getTool() {
		return tool;
	}
	

	
	/**
	 * @param tool The tool to set.
	 */
	public void setTool(Tool tool) {
		Logger.getInstance().log(
				Logger.TRACE,
				"WS1.setTool("+tool+")"); //$NON-NLS-1$ //$NON-NLS-2$
		//if(tool!=this.tool) {
			this.tool = tool;
			tool.reset();
			ows.ping();
	//	}
	}
	
	public void addGraphDescriptorListener(GraphDescriptorListener l) {
		// msgListener = listener;
		listenerList.add(GraphDescriptorListener.class, l);
	}
	
	protected class ObservableWorkSpace extends Observable {
		private WS1 ws;
		public ObservableWorkSpace(WS1 ws) {
			this.ws=ws;
		}
		public void ping() {
			setChanged();
			notifyObservers(this);
		}
		// XXX iokdbg-wsping trying sthg
		public void ping(String msg) {
			setChanged();
			notifyObservers(msg);
		}
	}
	
	public void initObservable() {
		ows=new ObservableWorkSpace(this);
	}
	
	public void addObserver(Observer o) {
		ows.addObserver(o);
	}
	
	public void deleteObserver(Observer o) {
		ows.deleteObserver(o);
	}
	

}
