package cds.aida.wsJlow;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.Point;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import javax.swing.Action;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;


import cds.aida.gui.CustomGDListener;
import cds.aida.gui.L10N;
import cds.aida.gui.Logger;
import cds.aida.gui.ToolW1View;
import cds.aida.tool.Tool;
import cds.aida.tool.ToolPort;
import cds.aida.tool.ToolsList;
import cds.aida.w1.ToolPortViewDummy;
import cds.aida.w1.ToolPortViewFiles;
import cds.aida.w1.ToolPortViewString;
import cds.jlow.client.codec.action.LoadAsAction;
import cds.jlow.client.codec.action.SaveAsAction;
import cds.jlow.client.descriptor.Attributs;
import cds.jlow.client.descriptor.Registerer;
import cds.jlow.client.graph.DefaultMPopupMenu;
import cds.jlow.client.graph.IManagerPopupMenu;
import cds.jlow.client.graph.Jlow;
import cds.jlow.client.graph.action.CopyAction;
import cds.jlow.client.graph.action.CutAction;
import cds.jlow.client.graph.action.ToFrontAction;
import cds.jlow.client.graph.event.DefaultDTL;
import cds.jlow.client.util.ToHtmlModule;
import cds.jlow.client.util.ToStringModule;
import cds.jlow.client.view.StringViewModule;
import cds.jlow.client.view.action.PropertyAction;
import cds.jlow.descriptor.Constant;
import cds.jlow.descriptor.IDescriptor;
import cds.jlow.descriptor.IPortDescriptor;
import cds.jlow.descriptor.IntegerDescriptor;
import cds.jlow.descriptor.PortDescriptor;
import cds.jlow.descriptor.TaskDescriptor;
import cds.jlow.util.DescriptorFactory;
import cds.jlow.util.Type;
import cds.jlow.util.Utils;
import cds.jlow.util.Module;


public class WSJ{
	public static int wsjcount = 0;
	Registerer register;
	Jlow graph;
	ToolsList tlist;

	JButton addButton;
	JPopupMenu adddatapopup;
	
	
	public WSJ(ToolsList tlist){
		wsjcount++;
		register = tlist.getReg();
		this.tlist = tlist;
		adddatapopup=new JPopupMenu();
		adddatapopup.add(new JMenuItem(new AddData(graph)));
		addButton = new JButton("Add Data");
		addButton.addMouseListener(new MouseAdapter() {
		    public void mouseReleased(MouseEvent e) {
	            adddatapopup.show(
	            		e.getComponent(),
	                    e.getX(),
						e.getY()
						);
		    }
		});
		
		//initTFW();
		graph = new Jlow(register);
		graph.addGraphDescriptorListener(new CustomGDListener());
		graph.setDropTargetListener(new WSJDrop(graph));
		addToRegisterCell(graph);
		
		JScrollPane scrollPaneGraph = new JScrollPane((Jlow) graph);

		//graph.setDropTargetListener(new DefaultDTL(graph));

		DefaultMPopupMenu mpm = new DefaultMPopupMenu(graph);
		mpm.initPopup();

		// Menu for graph
		mpm.insertItem(IManagerPopupMenu.GRAPHMENU, 0, new LoadAsAction(graph));
		mpm.insertSeparator(IManagerPopupMenu.GRAPHMENU, 1);
		
		mpm.insertItem(IManagerPopupMenu.GRAPHMENU, 2, new SaveAsAction(graph));
		mpm.insertSeparator(IManagerPopupMenu.GRAPHMENU, 3);
		
		//Paste from initPopup
		mpm.insertSeparator(IManagerPopupMenu.GRAPHMENU, 5);
		
		mpm.addItem(IManagerPopupMenu.GRAPHMENU, new TaskListAction(graph));
		mpm.addItem(IManagerPopupMenu.GRAPHMENU, new ExecServAction(graph));
		mpm.addItem(IManagerPopupMenu.GRAPHMENU, new GetAllObjectsAction(graph));
		mpm.addSeparator(IManagerPopupMenu.GRAPHMENU);
		
		// Add Data
		mpm.insertItem(IManagerPopupMenu.GRAPHMENU, 6, new AddData(graph));
		mpm.insertSeparator(IManagerPopupMenu.GRAPHMENU, 7);
		
		
		
		
		//mpm.addItem(IManagerPopupMenu.DATAMENU, new GetObjectAction(graph));


//		For the task
		mpm.addSeparator(IManagerPopupMenu.TASKMENU);
		mpm.addItem(IManagerPopupMenu.TASKMENU, new PropAction(graph));
		mpm.addItem(IManagerPopupMenu.TASKMENU, new PropertyAction(graph));

		
		//For the DATA
		mpm.addSeparator(IManagerPopupMenu.DATAMENU);
//		mpm.addItem(IManagerPopupMenu.DATAMENU, new AddValue(graph));
//		mpm.addSeparator(IManagerPopupMenu.DATAMENU);
//		mpm.addItem(IManagerPopupMenu.DATAMENU, new PropertyAction(graph));
		mpm.addItem(IManagerPopupMenu.DATAMENU, new PropertyAction(graph));
		
//		For the port
//		mpm.addItem(IManagerPopupMenu.PORTMENU, new AddData(graph));
//		mpm.addItem(IManagerPopupMenu.PORTMENU, new AddBool(graph));
//		mpm.addItem(IManagerPopupMenu.PORTMENU, new AddNum(graph));
//		mpm.addItem(IManagerPopupMenu.PORTMENU, new AddFits(graph));
//		mpm.addItem(IManagerPopupMenu.PORTMENU, new AddImag(graph));
//		mpm.addSeparator(IManagerPopupMenu.PORTMENU);
//		mpm.addItem(IManagerPopupMenu.PORTMENU, new PropertyAction(graph));
		graph.setPopupMenus(mpm);

	}
	
	public Jlow getGraph(){
		return graph;
	}
	

	
	private void addToRegisterCell(Jlow jlow) {
		
		try {
			jlow.registerCell("cds.jlow.descriptor.Variable", Class
					.forName("cds.jlow.client.graph.cell.DataCell"));
			jlow.registerCell("cds.jlow.descriptor.Constant", Class
					.forName("cds.jlow.client.graph.cell.DataCell"));
			jlow.registerCell("cds.jlow.descriptor.IntegerDescriptor", Class
					.forName("cds.jlow.client.graph.cell.DataCell"));
			jlow.registerCell("cds.jlow.client.sample.descriptor.BooleanDescriptor", Class
					.forName("cds.jlow.client.graph.cell.DataCell"));
			//jlow.registerCell("cds.jlow.client.descriptor.DataPortDescriptor",
			//		Class.forName("cds.jlow.client.graph.cell.PortCell"));
			
		} catch (Exception ex) {
			System.err.println("Mainframe.addToRegisterCell.Error : " + ex);
			ex.printStackTrace();
		}
	}
	


}