//
//------
//
//JLOW - Java Libraries fOr Workflow
//
//Author:  Cyril Pestel
//Address: Centre de Donnees astronomiques de Strasbourg
//11 rue de l'Universite
//67000 STRASBOURG
//FRANCE
//Email:   schaaff@astro.u-strasbg.fr, question@simbad.u-strasbg.fr
//
//-------
//
//In accordance with the international conventions about intellectual
//property rights this software and associated documentation files
//(the "Software") is protected. The rightholder authorizes :
//the reproduction and representation as a private copy or for educational
//and research purposes outside any lucrative use,
//subject to the following conditions:
//
//The above copyright notice shall be included.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
//OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, NON INFRINGEMENT,
//LOSS OF DATA, LOSS OF PROFIT, LOSS OF BARGAIN OR IMPOSSIBILITY
//TO USE SUCH SOFWARE. IN NO EVENT SHALL THE RIGHTHOLDER BE LIABLE
//FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
//TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH
//THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//For any other exploitation contact the rightholder.
//
//-----------
//
//Conformement aux conventions internationales relatives aux droits de
//propriete intellectuelle ce logiciel et sa documentation sont proteges.
//Le titulaire des droits autorise :
//la reproduction et la representation a titre de copie privee ou des fins
//d'enseignement et de recherche et en dehors de toute utilisation lucrative.
//Cette autorisation est faite sous les conditions suivantes :
//
//La mention du copyright portee ci-dessus devra etre clairement indiquee.
//
//LE LOGICIEL EST LIVRE "EN L'ETAT", SANS GARANTIE D'AUCUNE SORTE.
//LE TITULAIRE DES DROITS NE SAURAIT, EN AUCUN CAS ETRE TENU CONTRACTUELLEMENT
//OU DELICTUELLEMENT POUR RESPONSABLE DES DOMMAGES DIRECTS OU INDIRECTS
//(Y COMPRIS ET A TITRE PUREMENT ILLUSTRATIF ET NON LIMITATIF,
//LA PRIVATION DE JOUISSANCE DU LOGICIEL, LA PERTE DE DONNEES,
//LE MANQUE A GAGNER OU AUGMENTATION DE COUTS ET DEPENSES, LES PERTES
//D'EXPLOITATION,LES PERTES DE MARCHES OU TOUTES ACTIONS EN CONTREFACON)
//POUVANT RESULTER DE L'UTILISATION, DE LA MAUVAISE UTILISATION
//OU DE L'IMPOSSIBILITE D'UTILISER LE LOGICIEL, ALORS MEME
//QU'IL AURAIT ETE AVISE DE LA POSSIBILITE DE SURVENANCE DE TELS DOMMAGES.
//
//Pour toute autre utilisation contactez le titulaire des droits.
//

package cds.aida.wsJlow;

//import cds.jlow.codec.*;

import cds.jlow.client.graph.*;
//import cds.jlow.client.sample.service.*;
import cds.jlow.client.net.socket.*;
import cds.jlow.client.net.service.*;

import org.jgraph.graph.*;

import javax.swing.*;
//import java.io.*;

import java.awt.event.*;
import java.awt.geom.*;
import java.awt.*;

public class GetObjectAction extends AbstractAction {

	protected String host;
	protected int port;
	
	/**
	 * Create an action for getting an object of the Workflow in the remote
	 * server.
	 * 
	 * @param g
	 *            the graph where you draw
	 */
	public GetObjectAction(Jlow g) {
		// super("execserv");

		putValue(NAME, "Get");
		putValue("graph", g);
		
		host = "127.0.0.1";
		port = 2122;
	}

	public String getHost() {
		return host;
	}

	public void setHost(String host) {
		this.host = host;
	}

	public int getPort() {
		return port;
	}

	public void setPort(int port) {
		this.port = port;
	}

	/**
	 * Invoked when an action occurs.
	 * 
	 * @param e
	 *            an action event
	 */
	public void actionPerformed(ActionEvent e) {
		Jlow graph = (Jlow) getValue("graph");

		if (graph == null)
			return; // No graph selected
		
		Point2D point = graph.getMarqueeHandler().getCurrentPoint();
		Point pcell = new Point();
		pcell.setLocation(point.getX(), point.getY());

		Object cell = graph.getNextCell(pcell);
		
		Object userobj = null;
		if(cell!=null && cell instanceof DefaultGraphCell)
			userobj = ((DefaultGraphCell) cell).getUserObject();
		
		if(userobj!=null && userobj instanceof UserObject) {
		
			GetObjectService service = new GetObjectService(graph,
					new SocketProtocol(), host, port);
	
			Object key = ((UserObject) userobj).getModelIndex();
			
			if(key!=null) {
				System.out.println("Get "+key);
				service.execute(key.toString()+"\n");
			}
		}
	}
}
